/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2022  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.command;

import org.junit.Test;

import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.instanceOf;
import static org.hamcrest.Matchers.is;

public class BetterExceptionCommandTest {

    @Test
    public void testTabCompleteException() {
        BetterExceptionCommand cmd = new BetterExceptionCommand();
        try {
            cmd.tabComplete("test", "", new String[]{""});
            assert false;
        } catch (Exception e) {
            assertThat(e, is(instanceOf(CommandFrameworkException.class)));
            assertThat(e.getMessage(), is("de.steamwar.command.CommandFrameworkException: Error while tabcompleting () to type java.lang.String with parameter index 1"));
        }
    }

    @Test
    public void testValidationException() {
        BetterExceptionCommand cmd = new BetterExceptionCommand();
        try {
            cmd.execute("test", "", new String[]{""});
            assert false;
        } catch (Exception e) {
            assertThat(e, is(instanceOf(CommandFrameworkException.class)));
            assertThat(e.getMessage(), is("de.steamwar.command.CommandFrameworkException: Error while validating () to type java.lang.String with parameter index 1"));
        }
    }
}
